#!/usr/bin/python

from xml.dom.minidom import parse, parseString
import time,sys,os


class AFFILE:
    def __init__(self,fn):
        "Use afxml to read the metadata associated with this AFF file"
        self.xml = parseString(os.popen("afxml "+fn).read())
    def get_segq(self,segname):
        "Return the 8-byte value of a metadata segment as a 64-bit signed integer"
        return int(self.xml.getElementsByTagName(segname)[0].firstChild.wholeText)
    def get_seg(self,segname):
        try:
            elem  = self.xml.getElementsByTagName(segname)[0]
        except IndexError:
            return False                # nothing

        try:
            return int(elem.attributes.get("arg").firstChild.wholeText)
        except AttributeError:
            pass

        val = elem.firstChild.wholeText

        # Check for base64 coding
        try:
            if(elem.attributes.get("coding").firstChild.wholeText == 'base64'):
                import base64
                val = base64.standard_b64decode(val)
        except AttributeError:
            pass
        return val


def process(fn):
    af = AFFILE(fn)
    for prop in ['imagesize','segsize','device_sn','device_firmware','capabilities']:
        print prop,"=",af.get_seg(prop)

if(__name__=='__main__'):
    for fn in sys.argv[1:]:
        process(fn)
        
